/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021
 * ESP32 - SENSORES
*/


#define IP_STATIC

#define SEGUNDO 50
#define TSERVER 25
#define TREFRES 18000
#define TSENSOR 300


#define PIN_LED 2

//____________IP____________
#include <WiFi.h>

char mibufferIP[20];

const char* ssid       = "contraseña";
const char* password   = "nombreDeModem";
const char* ntpServer = "pool.ntp.org";
const long  gmtOffset_sec = 3600;
const int   daylightOffset_sec = 3600;

#if defined IP_STATIC
    // Set your Static IP address
    IPAddress local_IP(192, 168, 1, 150);
    // Set your Gateway IP address
    IPAddress gateway(192, 168, 1, 1);    
    IPAddress subnet(255, 255, 0, 0);
    IPAddress primaryDNS(8, 8, 8, 8);   //optional
    IPAddress secondaryDNS(8, 8, 4, 4); //optional
#endif

//___________18B20__________
#include <OneWire.h>
#define PIN_18B20  0
OneWire ds(PIN_18B20); // pin utilizado para el bus Onewire
int Otemperatura;
int getTemp(void);
char mibuffer18B20[25];
void getTempera18B20(void);

//____________LUZ___________
#define PIN_LUZ  34 //GPIO34
int Oluz;
char mibufferLuz[25];

//____________TEMPERATURA  - HUMEDAD ___________
#include "DHT.h"
#define PIN_DHT 4 
//#define DHTTYPE DHT11   // DHT 11 
#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)
DHT dht(PIN_DHT, DHTTYPE);
float h,t; 
char mibufferTemperatura[100];

//___________OLED_________
#include "olex.h"
#include <Wire.h>
//___________TIME_________
#include "time.h"
struct tm timeinfo;
char mibufferTime[50];
char mibufferDate[50];

//___________SERVER_________
#include <WebServer.h>
#include <ESPmDNS.h>

WebServer server(80);
#define MAXmibuffer2  1000
char mibuffer2[MAXmibuffer2 + 1];
char  Iniciohtml[] = "<!DOCTYPE HTML>\r\n <html><TITLE>SERVER - ESP32 </TITLE> <h1><b>Seta43_ESP32 </b></h1><hr>";
char  Cuerpohtml[] = "<h2> <font color=\"#660000\"><b> Palencia</b></font> </h2>  ";
char  Finhtml[] = " <hr>  xsetaseta@gmail.com </html>";

void handleRoot() 
  { 
   int z;
    digitalWrite(PIN_LED, 1); 
    strcpy(mibuffer2, Iniciohtml);
    strcat(mibuffer2, Cuerpohtml);
    strcat(mibuffer2, mibufferTime);
    strcat(mibuffer2, mibufferDate);
    strcat(mibuffer2, mibufferTemperatura);
    strcat(mibuffer2, mibuffer18B20);
    strcat(mibuffer2, mibufferLuz);
    strcat(mibuffer2, Finhtml);
    z = strlen(mibuffer2);
    Serial.println(z);
    server.send(z, "text/html", mibuffer2 );     
    delay(75);
    digitalWrite(PIN_LED, 0);
  }

void handleNotFound() 
{  
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i = 0; i < server.args(); i++) {
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }
  server.send(404, "text/plain", message);
}

//_______________END-SERVER_____________________


char VARI[100];
char TITULO[]="SENSORTOTAL";
int time1S=SEGUNDO,timeServer=TSERVER,timeRefres=TREFRES,timeSensor=TSENSOR;


void setup() 
{
  Serial.begin(9600);
  Serial.println(TITULO);
  pinMode(PIN_LED, OUTPUT);

  dht.begin();

  OleInit();
  xclearDisplay(); 
  xStringAT(0,3,TITULO);

  //connect to WiFi
#if defined IP_STATIC
    // Configures static IP address
     if (!WiFi.config(local_IP, gateway, subnet, primaryDNS, secondaryDNS)) 
    //  if (!WiFi.config(local_IP, gateway, subnet)) {   Serial.println("STA Failed to configure");    }
#endif
  Serial.printf("Conectando a %s ", ssid);
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) 
    {  delay(500);  Serial.print("."); }
  Serial.print(" Conectado con IP-");  Serial.println(WiFi.localIP() );
 
  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);

  server.on("/", handleRoot);
  server.onNotFound(handleNotFound);
  server.begin();
  Serial.println("HTTP server started");
  
  /*
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
  */
  delay(500);
}


void loop() 
{
  delay(20);
  time1S++; timeServer++; timeRefres++,timeSensor++;
  
  if(time1S>SEGUNDO)
    {
      time1S=0;
      printTime();   getLuz();
    }
    
  if(timeSensor>TSENSOR)
    {
      timeSensor=0;
      getTempera();   getTempera18B20();  
    }  
    
  if(timeServer>TSERVER)
    {
      timeServer=0;
      servidor();
    }
    
  if(timeRefres>TREFRES)
    {
      timeRefres=0;
      refresPantalla();
    }
    
}




void servidor()
{
   server.handleClient();
}


char *dias[]={"LUNES","MARTES","MIERCOLES","JUEVES","VIERNES","SABADO","DOMINGO"};

void printTime()
{
  if(!getLocalTime(&timeinfo))   { Serial.println("Failed to obtain time"); return;  }
  
  sprintf(VARI,"%02d:%02d:%02d ",timeinfo.tm_hour,timeinfo.tm_min,timeinfo.tm_sec);  
  ModeFont=0; xStringAT(0,0,VARI);
  sprintf(mibufferTime,"<p>%s</p>",VARI);
}


void refresPantalla()
{
  xclearDisplay();
  getLuz();
  getTempera();
  sprintf(mibufferIP,"IP-%d.%d.%d.%d",WiFi.localIP()[0],WiFi.localIP()[1],WiFi.localIP()[2],WiFi.localIP()[3] ); 
  ModeFont=0; xStringAT(0,7,mibufferIP);

  sprintf(VARI,"%s %02d-%02d-%02d",dias[timeinfo.tm_wday-1],timeinfo.tm_mday,timeinfo.tm_mon+1,timeinfo.tm_year+1900);
  sprintf(mibufferDate,"<p>%s</p>",VARI);
  ModeFont=0; xStringAT(0,1,VARI); 
}


void getTempera18B20(void)
{
   //_____________________18B20__________
    if (0 == getTemp())
    {
      Otemperatura = -1000;
      getTemp();
      if (Otemperatura != -1000)
      {
        sprintf(VARI,"18B20: %d.%d C ",Otemperatura/10,Otemperatura % 10);
        Serial.println(VARI);
        ModeFont=0; xStringAT(0,3,VARI);
        sprintf(mibuffer18B20,"<p>18B20: %d.%d &#176;C </p>",Otemperatura/10,Otemperatura % 10);    
      }
    }
}


void getTempera()
{
  h = dht.readHumidity();
  t = dht.readTemperature();
  if (isnan(h) || isnan(t)) 
    { Serial.println(F("ERROR DHT sensor!"));  return; }

  sprintf(VARI,"%3.1f C .... %2.0f%%",t,h);
  Serial.println(VARI);
  ModeFont=0; xStringAT(0,4,VARI);
  sprintf(mibufferTemperatura,"<p>AM2302 Temperatura= %3.1f &#176;C </p> <p>AM2302 Humedad= %2.0f%% </p>",t,h);
}


void getLuz()
{
  Oluz = analogRead(PIN_LUZ);
  sprintf(VARI,"Luz:%d      ",Oluz);
  Serial.println(VARI);
  ModeFont=0; xStringAT(0,5,VARI);
  sprintf(mibufferLuz,"<p>Luz: %d</p>",Oluz);
}


//______________________________________________________
//ds18B20

int getTemp(void)
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
  // byte decimal;


  if ( !ds.search(addr))  { ds.reset_search();  return 0;  }
  if ( OneWire::crc8( addr, 7) != addr[7]) ;// { SERIECONSOLA.println(F("CRC is not valid!")); return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28) ;// { SERIECONSOLA.print(F("Device is not recognized")); return -1; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);
  ds.write(0x4B);
  ds.write(0x46);
  ds.write(0x7F);    // 12-bit sampling resolution (default)
  //ds.write(0x5F);    // 11-bit
  //ds.write(0x3F);    // 10-bit
  //ds.write(0x1F);    // 9-bit
  // delay(500);

  ds.reset();  ds.select(addr);  ds.write(0x44, 1); // start conversion, with parasite power on at the end
  delay(750);

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();

  z = (data[1] << 8) | data[0];
  temp = z;
  temp = (temp * 625) / 1000;
  Otemperatura = temp;
  return 1;
}
